package arzumify.coretechs.energy;

import arzumify.polyenergy.api.EnergyProvider;
import arzumify.polyenergy.api.EnergyReceiver;

import java.util.Set;

public class Common {
    public static long extract(long rate, long capacity, long energy, Set<EnergyProvider> providerSet, EnergyReceiver self) {
        var needToExtract = Math.min(rate, Math.min(capacity - energy, rate));
        for (EnergyProvider provider : providerSet) {
            if (needToExtract <= 0) {
                break;
            }
            long extracted = provider.extract(needToExtract, self);
            energy += extracted;
            needToExtract -= extracted;
        }
        return energy;
    }
}
