package arzumify.coretechs.energy;

import arzumify.coretechs.BlockEntityTypes;
import arzumify.coretechs.CoreTechs;
import com.mojang.serialization.MapCodec;
import eu.pb4.polymer.blocks.api.BlockModelType;
import eu.pb4.polymer.blocks.api.PolymerBlockModel;
import eu.pb4.polymer.blocks.api.PolymerBlockResourceUtils;
import eu.pb4.polymer.blocks.api.PolymerTexturedBlock;
import net.fabricmc.fabric.api.event.lifecycle.v1.ServerBlockEntityEvents;
import net.minecraft.block.BlockState;
import net.minecraft.block.BlockWithEntity;
import net.minecraft.block.entity.BlockEntity;
import net.minecraft.block.entity.BlockEntityTicker;
import net.minecraft.block.entity.BlockEntityType;
import net.minecraft.server.world.ServerWorld;
import net.minecraft.util.Identifier;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import org.jetbrains.annotations.Nullable;

public class CopperWire extends BlockWithEntity implements PolymerTexturedBlock {
    public CopperWire(Settings setting) {
        super(setting);
        this.state = PolymerBlockResourceUtils.requestBlock(BlockModelType.TRANSPARENT_BLOCK, PolymerBlockModel.of(Identifier.of(CoreTechs.MOD_ID, "block/copper_wire")));
    }

    @Override
    protected MapCodec<? extends BlockWithEntity> getCodec() {
        return createCodec(CopperWire::new);
    }

    private final BlockState state;

    @Override
    public BlockState getPolymerBlockState(BlockState state) {
        return this.state;
    }

    @Override
    public @Nullable BlockEntity createBlockEntity(BlockPos pos, BlockState state) {
        return new CopperWireEntity(pos, state);
    }

    @Override
    protected void onStateReplaced(BlockState state, World world, BlockPos pos, BlockState newState, boolean moved) {
        System.out.println("onStateReplaced");
        if (!world.isClient() && state.isOf(newState.getBlock())) {
            System.out.println("world is not client");
            var entity = world.getBlockEntity(pos);
            System.out.println("entity: " + entity);
            if (entity != null) {
                ((ServerBlockEntityEvents.Unload) entity).onUnload(entity, (ServerWorld) world);
            }
        }
        super.onStateReplaced(state, world, pos, newState, moved);
    }

    @Override
    public @Nullable <T extends BlockEntity> BlockEntityTicker<T> getTicker(World world, BlockState state, BlockEntityType<T> type) {
        return validateTicker(type, BlockEntityTypes.COPPER_WIRE, CopperWireEntity::tick);
    }
}
